<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" width="1100px">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-row>
        <el-col :span="8">
          <el-form-item label="计划编码" prop="planCode">
            <el-input v-model="formData.planCode" placeholder="请输入计划编码" />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="计划名称" prop="planName">
            <el-input v-model="formData.planName" placeholder="请输入计划名称" />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="维保类型" prop="planType">
            <el-select
              v-model="formData.planType"
              placeholder="请选择维保类型"
              clearable
              class="!w-240px"
            >
              <el-option
                v-for="dict in getStrDictOptions(DICT_TYPE.MES_MAINTAIN_TYPE)"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="8">
          <el-form-item label="开始日期" prop="startDate">
            <el-date-picker
              v-model="formData.startDate"
              type="date"
              value-format="x"
              placeholder="选择开始日期"
            />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="结束日期" prop="endDate">
            <el-date-picker
              v-model="formData.endDate"
              type="date"
              value-format="x"
              placeholder="选择结束日期"
            />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="是否启用" prop="isEnable">
            <el-radio-group v-model="formData.isEnable">
              <el-radio
                v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
                :key="dict.value"
                :label="dict.value"
              >
                {{ dict.label }}
              </el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="8">
          <el-form-item label="维保等级" prop="planLevel">
            <el-select
              v-model="formData.planLevel"
              placeholder="请选择维保等级"
              clearable
              class="!w-240px"
            >
              <el-option
                v-for="dict in getStrDictOptions(DICT_TYPE.MES_MANTAIN_LEVEL)"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="频率" prop="cycleCount">
            <el-input v-model="formData.cycleCount" placeholder="请输入频率" />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="频率单位" prop="cycleUnit">
            <el-radio-group v-model="formData.cycleUnit">
              <el-radio
                v-for="dict in getStrDictOptions(DICT_TYPE.MES_MAINTAIN_TIME_UNIT)"
                :key="dict.value"
                :label="dict.value"
              >
                {{ dict.label }}
              </el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="8">
          <el-form-item label="上次执行时间" prop="lastTime">
            <el-date-picker
              v-model="formData.lastTime"
              type="date"
              value-format="x"
              placeholder="选择上次执行时间"
            />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="计算公式" prop="formulaCode">
            <el-input v-model="formData.formulaCode" placeholder="请输入计算公式" />
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="备注" prop="remark">
            <el-input v-model="formData.remark" placeholder="请输入备注" />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <!-- 子表的表单 -->
    <el-tabs v-model="subTabsName">
      <el-tab-pane label="维保计划设备" name="dvCheckDevice">
        <DvCheckDeviceForm ref="dvCheckDeviceFormRef" :plan-id="formData.id" />
      </el-tab-pane>
      <el-tab-pane label="维保计划项目" name="dvCheckSubject">
        <DvCheckSubjectForm ref="dvCheckSubjectFormRef" :plan-id="formData.id" />
      </el-tab-pane>
    </el-tabs>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, getBoolDictOptions, DICT_TYPE } from '@/utils/dict'
import { DvCheckApi, DvCheckVO } from '@/api/mes/dvcheck'
import DvCheckDeviceForm from './components/DvCheckDeviceForm.vue'
import DvCheckSubjectForm from './components/DvCheckSubjectForm.vue'

/** 维保计划 表单 */
defineOptions({ name: 'DvCheckForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  planCode: undefined,
  planName: undefined,
  planType: undefined,
  startDate: undefined,
  endDate: undefined,
  status: undefined,
  remark: undefined,
  isEnable: undefined,
  cycleUnit: undefined,
  cycleCount: undefined,
  planLevel: undefined,
  lastTime: undefined,
  formulaCode: undefined
})
const formRules = reactive({
  planCode: [{ required: true, message: '计划编码不能为空', trigger: 'blur' }],
  planType: [{ required: true, message: '计划类型不能为空', trigger: 'change' }],
  isEnable: [{ required: true, message: '是否启用不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 子表的表单 */
const subTabsName = ref('dvCheckDevice')
const dvCheckDeviceFormRef = ref()
const dvCheckSubjectFormRef = ref()

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await DvCheckApi.getDvCheck(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 校验子表单
  try {
    await dvCheckDeviceFormRef.value.validate()
  } catch (e) {
    subTabsName.value = 'dvCheckDevice'
    return
  }
  try {
    await dvCheckSubjectFormRef.value.validate()
  } catch (e) {
    subTabsName.value = 'dvCheckSubject'
    return
  }
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as DvCheckVO
    // 拼接子表的数据
    data.dvCheckDevices = dvCheckDeviceFormRef.value.getData()
    data.dvCheckSubjects = dvCheckSubjectFormRef.value.getData()
    if (formType.value === 'create') {
      await DvCheckApi.createDvCheck(data)
      message.success(t('common.createSuccess'))
    } else {
      await DvCheckApi.updateDvCheck(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    planCode: undefined,
    planName: undefined,
    planType: undefined,
    startDate: undefined,
    endDate: undefined,
    status: undefined,
    remark: undefined,
    isEnable: undefined,
    cycleUnit: undefined,
    cycleCount: undefined,
    planLevel: undefined,
    lastTime: undefined,
    formulaCode: undefined
  }
  formRef.value?.resetFields()
}
</script>
